!
! ARM test: Uploads the ARM program to the ARM's memory, then enables
! the ARM. After a little while, reads the first few bytes of the ARM's
! memory (so one can see if the ARM program had any effect).
!

		.SECTION .text

		.GLOBL	start
		.ALIGN	5
start:
		sts.l	pr,@-r15
		mov.l	_start_InitCache,r0
		jsr	@r0
		nop
		mov.l	_start_Main,r0
		jmp	@r0
		nop

			.ALIGN	2
_start_InitCache:	.LONG	_InitCache
_start_Main:		.LONG	Main

		.ALIGN	5
Main:	

		mov.l	Main_SetupExceptionHandler,r0
		jsr	@r0
		nop

		bsr	PokeARM
		nop

		mov.l	Main_DisableExceptionHandler,r0
		jsr	@r0
		nop

		mov.l	Main_DisableCache,r0
		jsr	@r0

		lds.l	@r15+,pr
		rts
		nop

				.ALIGN	2
Main_DisableCache:		.LONG	_DisableCache
Main_SetupExceptionHandler:	.LONG	_SetupExceptionHandler
Main_DisableExceptionHandler:	.LONG	_DisableExceptionHandler


		.ALIGN	5
PokeARM:
		sts.l	pr,@-r15

		mov.l	PokeARM_ARMControl,r7

		mov.l	@r7,r0			! Disable ARM
		or	#1,r0
		mov.l	r0,@r7

		mov.l	PokeARM_armcodestart,r0
		mov.l	PokeARM_armcodeend,r1
		mov.l	PokeARM_ARMMemory,r2
		mov.l	PokeARM_FIFO,r3

		sub	r0,r1
		shlr2	r1
PokeARM_copyLong:
		mov.l	@r0+,r4
		mov.l	r4,@r2
		add	#4,r2

PokeARM_copyLong_wait:			! Wait for FIFO to become empty
		mov.l	@r3,r4
		mov	#1,r5
		tst	r5,r4
		bt	PokeARM_copyLong_wait

		dt	r1
		bf	PokeARM_copyLong

		mov.l	@r7,r0			! Enable ARM
		mov	#~1,r1
		and	r1,r0
		mov.l	r0,@r7

		mov.l	PokeARM_scWaitVBL,r8	! Wait a while, so the ARM
		jsr	@r8			! code finishes executing
		nop
		jsr	@r8
		nop

		mov.l	PokeARM_ARMMemory,r14	! Read first block of ARM
		mov.l	@r14+,r0		! memory, and dump to console
		mov.l	@r14+,r1
		mov.l	@r14+,r2
		mov.l	@r14+,r3
		mov.l	@r14+,r4
		mov.l	@r14+,r5
		mov.l	@r14+,r6
		mov.l	@r14+,r7
		mov.l	@r14+,r8
		mov.l	@r14+,r9
		mov.l	@r14+,r10
		mov.l	@r14+,r11
		mov.l	@r14+,r12
		mov.l	@r14+,r13
		mov.l	@r14+,r14
		trapa	#0
		
		lds.l	@r15+,pr
		rts
		nop

			.ALIGN	2
PokeARM_ARMControl:	.LONG	0xa0702c00
PokeARM_armcodestart:	.LONG	armcode
PokeARM_armcodeend:	.LONG	armcode_end
PokeARM_ARMMemory:	.LONG	0xa0800000
PokeARM_FIFO:		.LONG	0xa05f688c
PokeARM_scWaitVBL:	.LONG	_scWaitVBL	
