
!
! Memory access timing framework.
!

		.INCLUDE "PVR2_Regs.i"
		.INCLUDE "SH4_Regs.i"
		.INCLUDE "Screen.i"
	
		.SECTION .text

		.GLOBL	start
		.ALIGN	5
start:
		mov.l	start_Main,r0
		jmp	@r0
		nop

		.ALIGN	2
start_Main:	.long	Main

		.ALIGN	5

Main:
		sts.l	pr,@-r15

		mov.l	Main_InitFPU,r0
		jsr	@r0
		nop

		mov.l	Main_InitCache,r0
		jsr	@r0
		nop

		mov.l	Main_SetupExceptionHandler,r0
		jsr	@r0
		nop

		mov.l	Main_scInit,r0
		jsr	@r0
		nop
	
		add	#-8,r15
		mov	#640/8,r4
		shll2	r4
		shll	r4
		mov	#480/8,r5
		shll2	r5
		shll	r5
		mov	#SCREEN_LORES,r6
		mov	#SCREEN_LORES,r7
		mov	#SCREEN_50HZ,r0
		mov.l	r0,@(0,r15)
		mov	#SCREEN_ARGB8888,r0
		mov.l	r0,@(4,r15)
		mov.l	Main_scSetMode,r0
		jsr	@r0
		nop
		add	#8,r15

		mov.l	Main_scEnable,r0
		jsr	@r0
		mov	#1,r4

		bsr	AccessMemory
		nop

		mov.l	Main_BrowseVideoMemory,r0
		jsr	@r0
		nop

		mov.l	Main_SetIMASK,r0
		jsr	@r0
		mov	#0xf,r4

		mov.l	Main_DisableExceptionHandler,r0
		jsr	@r0
		nop

		mov.l	Main_DisableCache,r0
		jsr	@r0
		nop

		lds.l	@r15+,pr
		rts
		nop

				.ALIGN	5
Main_InitFPU:			.long	InitFPU
Main_InitCache:			.long	_InitCache
Main_SetupExceptionHandler:	.long	_SetupExceptionHandler
Main_SetIMASK:			.long	_SetIMASK
Main_scInit:			.long	_scInit
Main_scSetMode:			.long	_scSetMode
Main_scEnable:			.long	_scEnable
Main_DisableExceptionHandler:	.long	_DisableExceptionHandler
Main_DisableCache:		.long	_DisableCache
Main_BrowseVideoMemory:		.long	_BrowseVideoMemory
	
		.ALIGN	5
InitFPU:
		mov	#4,r0
		shll16	r0
		lds	r0,fpscr
		nop
		nop
		fschg
		fldi0	fr0
		fldi0	fr1
		fmov	dr0,dr2
		fmov	dr0,dr4
		fmov	dr0,dr6
		fmov	dr0,dr8
		fmov	dr0,dr10
		fmov	dr0,dr12
		fmov	dr0,dr14
		fmov	dr0,xd0
		fmov	dr0,xd2
		fmov	dr0,xd4
		fmov	dr0,xd6
		fmov	dr0,xd8
		fmov	dr0,xd10
		fmov	dr0,xd12
		fmov	dr0,xd14
		rts
		fschg


AccessMemory:
		sts.l	pr,@-r15

AccessMemory_frame:

		mov.l	AccessMemory_StartColor,r1
		mov.l	AccessMemory_BGColor,r0
		mov.l	r1,@r0

		mova	AccessMemory_StartPos,r0	! Read beam position at beginning
		mov.l	AccessMemory_BeamPos,r1		! of operation
		mov.l	@r1,r1
		mov.l	r1,@r0


		bsr	LinearRead			! Do some memory access
		nop


		mova	AccessMemory_StartPos,r0	! Read final beam position,
		mov.l	AccessMemory_BeamPos,r1		! calculate difference,
		mov.l	@r0,r0				! and print number of lines
		mov.l	@r1,r1
		sub	r0,r1
		mov	#0x2f,r0
		shll2	r0
		shll2	r0
		or	#0xf,r0
		and	r0,r1
		mov.l	AccessMemory_SerialWriteHexLong,r0
		jsr	@r0
		mov	r1,r4

		mov.l	AccessMemory_SerialWriteChar,r0
		jsr	@r0
		mov	#0xd,r4
		mov.l	AccessMemory_SerialWriteChar,r0
		jsr	@r0
		mov	#0xa,r4

		mov.l	AccessMemory_EndColor,r1
		mov.l	AccessMemory_BGColor,r0
		mov.l	r1,@r0

		mov.l	AccessMemory_scWaitVBL,r0
		jsr	@r0
		nop

		mov.l	AccessMemory_SerialCheckInput,r0
		jsr	@r0
		nop

		tst	r0,r0
		bt	AccessMemory_frame

		lds.l	@r15+,pr
		rts
		nop

				.ALIGN	5
AccessMemory_SerialCheckInput:	.LONG	_SerialCheckInput
AccessMemory_SerialWriteHexLong: .LONG	_SerialWriteHexLong
AccessMemory_SerialWriteChar:	.LONG	_SerialWriteChar
AccessMemory_scWaitVBL:		.LONG	_scWaitVBL
AccessMemory_BeamPos:		.LONG	PVR2REGS+BEAMPOS*4
AccessMemory_StartPos:		.LONG	0
AccessMemory_BGColor:		.LONG	PVR2REGS+BORDERCOLOR*4
AccessMemory_StartColor:	.LONG	0x00800000
AccessMemory_EndColor:		.LONG	0x00000000


LinearRead:
		mov.l	LinearRead_Delta,r3
		mov.l	LinearRead_Count2,r2
LinearRead_iter2:
		mov.l	LinearRead_StartAddr,r0
		mov.l	LinearRead_Count1,r1

LinearRead_iter1:
		movca.l	r0,@r0
!		pref	@r0
		dt	r1
		bf/s	LinearRead_iter1
		add	r3,r0

		dt	r2
		bf	LinearRead_iter2
	
		rts
		nop

		.ALIGN	4
LinearRead_StartAddr:	.LONG	0x8c020000
LinearRead_Delta:	.LONG	2048
LinearRead_Count1:	.LONG	16
LinearRead_Count2:	.LONG	131072/16
