!
! Simple video-memory browser.
!
! Move up/down with:
!
! a s d f g
! z x c v b
! | | | | +- 0x100000 bytes
! | | | +--- 0x10000 bytes
! | | +----- 0x1000 bytes
! | +------- 0x100 bytes
! +--------- 0x40 bytes
!
! Space exits.
!

		.INCLUDE "PVR2_Regs.i"
		.INCLUDE "Screen.i"

		.SECTION .text


		.GLOBL	_BrowseVideoMemory
		.ALIGN	5	
_BrowseVideoMemory:
		mov.l	r14,@-r15
		mov.l	r13,@-r15
		mov.l	r12,@-r15
		mov.l	r11,@-r15
		mov.l	r10,@-r15
		mov.l	r9,@-r15
		mov.l	r8,@-r15
		sts.l	pr,@-r15

		mov.l	_BrowseVideoMemory_StartAddr,r9
		mov.l	_BrowseVideoMemory_SerialReadUChar,r10
		mov.l	_BrowseVideoMemory_SerialWriteChar,r11
		mov.l	_BrowseVideoMemory_SerialWriteHexByte,r12
		mov.l	_BrowseVideoMemory_SerialWriteHexLong,r13
		mov.l	_BrowseVideoMemory_SerialWriteString,r14

_BrowseVideoMemory_nextDump:
		mov.l	_BrowseVideoMemory_Screen,r0
		mov.l	_BrowseVideoMemory_scSetBuffer,r1
		mov.l	@(Screen_Pitch,r0),r5
		jsr	@r1
		mov	r9,r4

		mov.l	r9,@-r15
	
		mov	#4,r8
_BrowseVideoMemory_row:	
		jsr	@r13
		mov	r9,r4
		jsr	@r11
		mov	#':',r4
		jsr	@r11
		mov	#' ',r4

		.REPT	4
		jsr	@r13
		mov.l	@r9+,r4
		jsr	@r11
		mov	#' ',r4
		.ENDR
	
		jsr	@r11
		mov	#0xd,r4
		jsr	@r11
		mov	#0xa,r4

		dt	r8
		bf	_BrowseVideoMemory_row

		mov.l	@r15+,r9
	
		jsr	@r10
		nop

		mov	#0,r2
	
		cmp/eq	#'a',r0
		bf	_BrowseVideoMemory_nUp1
		mov.l	_BrowseVideoMemory_Step1,r2
		neg	r2,r2
_BrowseVideoMemory_nUp1:
		cmp/eq	#'z',r0
		bf	_BrowseVideoMemory_nDown1
		mov.l	_BrowseVideoMemory_Step1,r2
_BrowseVideoMemory_nDown1:

		cmp/eq	#'s',r0
		bf	_BrowseVideoMemory_nUp2
		mov.l	_BrowseVideoMemory_Step2,r2
		neg	r2,r2
_BrowseVideoMemory_nUp2:
		cmp/eq	#'x',r0
		bf	_BrowseVideoMemory_nDown2
		mov.l	_BrowseVideoMemory_Step2,r2
_BrowseVideoMemory_nDown2:

		cmp/eq	#'d',r0
		bf	_BrowseVideoMemory_nUp3
		mov.l	_BrowseVideoMemory_Step3,r2
		neg	r2,r2
_BrowseVideoMemory_nUp3:
		cmp/eq	#'c',r0
		bf	_BrowseVideoMemory_nDown3
		mov.l	_BrowseVideoMemory_Step3,r2
_BrowseVideoMemory_nDown3:

		cmp/eq	#'f',r0
		bf	_BrowseVideoMemory_nUp4
		mov.l	_BrowseVideoMemory_Step4,r2
		neg	r2,r2
_BrowseVideoMemory_nUp4:
		cmp/eq	#'v',r0
		bf	_BrowseVideoMemory_nDown4
		mov.l	_BrowseVideoMemory_Step4,r2
_BrowseVideoMemory_nDown4:

		cmp/eq	#'g',r0
		bf	_BrowseVideoMemory_nUp5
		mov.l	_BrowseVideoMemory_Step5,r2
		neg	r2,r2
_BrowseVideoMemory_nUp5:
		cmp/eq	#'b',r0
		bf	_BrowseVideoMemory_nDown5
		mov.l	_BrowseVideoMemory_Step5,r2
_BrowseVideoMemory_nDown5:

		add	r2,r9

		cmp/eq	#' ',r0
		bf	_BrowseVideoMemory_nextDump

		mova	_BrowseVideoMemory_StartAddr,r0
		mov.l	r9,@r0

		lds.l	@r15+,pr
		mov.l	@r15+,r8
		mov.l	@r15+,r9
		mov.l	@r15+,r10
		mov.l	@r15+,r11
		mov.l	@r15+,r12
		mov.l	@r15+,r13
		rts
		mov.l	@r15+,r14

					.ALIGN	5
_BrowseVideoMemory_scSetBuffer:		.LONG	_scSetBuffer
_BrowseVideoMemory_Screen:		.LONG	_Screen
_BrowseVideoMemory_SerialReadUChar:	.LONG	_SerialReadUChar
_BrowseVideoMemory_SerialWriteChar:	.LONG	_SerialWriteChar
_BrowseVideoMemory_SerialWriteHexByte:	.LONG	_SerialWriteHexByte
_BrowseVideoMemory_SerialWriteHexLong:	.LONG	_SerialWriteHexLong
_BrowseVideoMemory_SerialWriteString:	.LONG	_SerialWriteString
_BrowseVideoMemory_StartAddr:		.LONG	0xa5000000
_BrowseVideoMemory_Step1:		.LONG	0x40
_BrowseVideoMemory_Step2:		.LONG	0x100
_BrowseVideoMemory_Step3:		.LONG	0x1000
_BrowseVideoMemory_Step4:		.LONG	0x10000
_BrowseVideoMemory_Step5:		.LONG	0x100000
