
		.INCLUDE "SH4_Regs.i"

		.SECTION .text

		
!-----------------------------------------------------------------------------
! int oldCACR SetCACR(int andCACR, int orCACR)
!
! Allows the user to modify CACR
!
! in	r4	int	andCACR
!	r5	int	orCACR
	
		.GLOBL	_SetCACR
		.ALIGN	5
_SetCACR:
		mov	#0xa0,r1
		shll16	r1
		mova	_SetCACR_P2Entry,r0
		shll8	r1
		or	r1,r0
		jmp	@r0
		nop

		.ALIGN	2
_SetCACR_P2Entry:
		mov	#(CCN>>24),r0
		shll16	r0
		shll8	r0
		mov.l	@(CCN_CCR-CCN,r0),r1
		mov	r1,r2
		and	r4,r2
		or	r5,r2
		mov.l	r2,@(CCN_CCR-CCN,r0)
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		rts
		nop



!-----------------------------------------------------------------------------
! void InitCache(void)
!
! Invalidates & enables IC & OC
!

		.GLOBL	_InitCache
		.ALIGN	5
_InitCache:
		sts.l	pr,@-r15

		mov	#9,r0
		shll8	r0
		or	#0xd,r0
		mov	r0,r5
		bsr	_SetCACR
		mov	#0,r4

		lds.l	@r15+,pr
		rts
		nop



!-----------------------------------------------------------------------------
! void DisableCache(void)
!
! Flushes, disables & invalidates IC & OC
!

		.GLOBL	_DisableCache
		.ALIGN	5
_DisableCache:
		sts.l	pr,@-r15

		bsr	_WritebackOC
		nop
		mov	#8,r0
		shll8	r0
		or	#8,r0
		mov	r0,r5
		bsr	_SetCACR
		mov	#0,r4

		lds.l	@r15+,pr
		rts
		nop



!-----------------------------------------------------------------------------
! void WritebackOC(void)
!
! Flushes OC to main memory
!

		.GLOBL	_WritebackOC
		.ALIGN	5
_WritebackOC:
		mov	#0xf4,r0
		shll16	r0
		mov	#2,r1
		shll8	r0
		mov	#0,r2
		shll8	r1

_WritebackOC_wbEntry:
		mov.l	r2,@r0
		dt	r1
		bf/s	_WritebackOC_wbEntry
		add	#32,r0

		rts
		nop
