
! Screen struct

Screen_Flags		=	0			! int8		Current display-hardware settings
Screen_DisplayType	=	1			! int8		Current display-type, as given by GetDisplayType()
Screen_Base		=	4			! int		Base address of graphics
Screen_Pitch		=	8			! int		Pitch between two lines
Screen_Width		=	12			! int		Width of bitmap window, in pixels
Screen_Height		=	16			! int		Height of bitmap window, in pixels
Screen_Format		=	20			! int		Bitmap window pixel format
Screen_HorizClock	=	24			! int		horizontal resolution (SCREEN_LORES or SCREEN_HIRES)
Screen_VertClock	=	28			! int		vertical resolution (SCREEN_LORES or SCREEN_HIRES)
Screen_RefreshFreq	=	32			! int		Refresh frequency (SCREEN_50HZ or SCREEN_60HZ)
Screen_XCenter		=	36			! int		Center position of bitmap window, rel. to screen center (measured in (HIRES, HIRES) pixels)
Screen_YCenter		=	40			! int		    -"-
Screen_DisplayOriginX	=	44			! int		Center position of screen, in native screen pixels
Screen_DisplayOriginY	=	48			! int		    -"-
Screen_SIZEOF		=	52

! Bit flags in Screen_Flags:

SCREEN_FLAGS_31KHZ	=	0x01			! 0 = 15kHz, 1 = 30kHz
SCREEN_FLAGS_60HZ	=	0x02			! 0 = 50Hz, 1 = 60Hz
SCREEN_FLAGS_INTERLACE	=	0x04			! Interlace enable
SCREEN_FLAGS_DOUBLEPIXEL =	0x08			! Double pixel width
SCREEN_FLAGS_DOUBLESCAN	=	0x10			! Double scanline height
SCREEN_FLAGS_ENABLE	=	0x20			! 0 = display disabled, 1 = display enabled

! Parameters for SetDisplayMode()

SCREEN_LORES			= 0
SCREEN_HIRES			= 1

SCREEN_50HZ			= 0
SCREEN_60HZ			= 1

SCREEN_RGB555			= 0
SCREEN_RGB565			= 1
SCREEN_ARGB8888			= 3



! Display type information returned by scGetDisplayType()

! Default refresh rate

DISPLAY_DEFAULT_MASK		= 0x40
DISPLAY_DEFAULT_50HZ		= 0x00
DISPLAY_DEFAULT_60HZ		= 0x40

! TV-system signal type

DISPLAY_BROADCAST_MASK		= 0x30
DISPLAY_BROADCAST_NTSC		= 0x00
DISPLAY_BROADCAST_PAL		= 0x10
DISPLAY_BROADCAST_PALM		= 0x20
DISPLAY_BROADCAST_PALN		= 0x30

! Video cable type

DISPLAY_CABLE_MASK		= 0x0c
DISPLAY_CABLE_VGA		= 0x00
DISPLAY_CABLE_UNKNOWN		= 0x04	! Should never happen
DISPLAY_CABLE_RGB		= 0x08
DISPLAY_CABLE_COMPOSITE		= 0x0c	! Either composite video, or no cable connected

! Video system type - as in: VGA, or 60Hz TV, or 50Hz TV

DISPLAY_SYSTEM_MASK		= 0x03
DISPLAY_SYSTEM_VGA		= 0x00
DISPLAY_SYSTEM_NTSC		= 0x01
DISPLAY_SYSTEM_PAL		= 0x02
DISPLAY_SYSTEM_UNKNOWN		= 0x03	! Should never happen



