
		.INCLUDE "SuperStrip.i"
	

!----------------------------------------------------------------------
! void UberStrip_calcVertexNormals(SuperStrip* superStrip, Vtx* vertices,
!		Vtx* normals, int numVertices)
!
! Calculates vertex normals for a SuperStripped object
!
! in	r4	SuperStrip*	SuperStrip
!	r5	Vtx*		Vertices
!	r6	Vtx*		Output normals
!	r7	int		Number of vertices
!

		.GLOBAL	_UberStrip_calcVertexNormals
		.ALIGN	5
_UberStrip_calcVertexNormals:
		fmov.s	fr12,@-r15
		mov.l	r9,@-r15
		mov.l	r8,@-r15
		sts.l	pr,@-r15

		mov.l	r7,@-r15
		mov.l	r6,@-r15
		mov.l	r5,@-r15
		mov.l	r4,@-r15

		mov.l	_UberStrip_calcVertexNormals_stdClearMem,r0	! First, clear all normals
		mov	#Vtx_SIZEOF,r1
		mov	r6,r4
		mul.l	r1,r7
		jsr	@r0
		sts	macl,r5

		mov.l	@r15+,r4
		mov.l	@r15+,r5
		mov.l	@r15+,r6
		mov.l	@r15+,r7


		mov.l	r7,@-r15

		mov	r6,r9
		sub	r5,r9
	
		mov.l	@r4+,r8						! Then, iterate over all SuperStrips,
_UberStrip_calcVertexNormals_superStrip:				! calculating face normals for each striptri,
									! and adding the face normal to all the vertices
		mov.l	@r4+,r7						! that make up the striptri
		mov.l	_UberStrip_calcVertexNormals_addrMask,r0
		mov.l	@r4+,r1
		add	#-2,r7
		mov.l	@r4+,r2
		and	r0,r1
		and	r0,r2
		add	r5,r1
		add	r5,r2

		fldi1	fr12
_UberStrip_calcVertexNormals_stripVertex:
		mov	r1,r0
		mov.l	_UberStrip_calcVertexNormals_addrMask,r3
		mov	r2,r1
		mov.l	@r4+,r2
		and	r3,r2
		add	r5,r2

		fmov.s	@r0+,fr0
		fmov.s	@r0+,fr1
		fmov.s	@r0+,fr2
		fmov.s	@r1+,fr4
		fmov.s	@r1+,fr5
		fmov.s	@r1+,fr6
		fsub	fr0,fr4
		fmov.s	@r2+,fr8
		fsub	fr1,fr5
		fmov.s	@r2+,fr9
		fsub	fr2,fr6
		fmov.s	@r2+,fr10
		fsub	fr0,fr8
		add	r9,r0
		fsub	fr1,fr9
		add	r9,r1
		fsub	fr2,fr10
		add	r9,r2

		fldi0	fr7
		fldi0	fr11
	
		fipr	fv4,fv4
		fipr	fv8,fv8
		
		fsrra	fr7
		fsrra	fr11

		fmul	fr7,fr4
		add	#-12,r0
		fmul	fr7,fr5
		add	#-12,r1
		fmul	fr7,fr6
		add	#-12,r2

		fmul	fr11,fr8
		fmul	fr11,fr9
		fldi0	fr7
		fmul	fr11,fr10
		fldi0	fr11

		fmov	fr5,fr0
		fmul	fr10,fr0
		fmov	fr6,fr1
		fmul	fr9,fr1
		fsub	fr1,fr0

		fmov	fr4,fr2
		fmul	fr10,fr2
		fmov	fr6,fr1
		fmul	fr8,fr1
		fsub	fr2,fr1

		fmov	fr4,fr2
		fmul	fr9,fr2
		fmov	fr5,fr3
		fmul	fr8,fr3
		fsub	fr3,fr2

		fipr	fv0,fv0

		fipr	fv4,fv8

		fmov.s	@r0+,fr4
		fmov.s	@r0+,fr5
		fmov.s	@r0+,fr6

		fsrra	fr3

		fldi1	fr7
		fmov.s	@r1+,fr8
		fsub	fr11,fr7
		fmov.s	@r1+,fr9
		fmov.s	@r1+,fr10

		fmul	fr12,fr3
!		fmul	fr7,fr3		! weighted summation does not work yet

		fmul	fr3,fr2
		fmul	fr3,fr1
		fmul	fr3,fr0
	
		fadd	fr2,fr6
		fadd	fr1,fr5
		fadd	fr0,fr4

		fmov.s	fr6,@-r0
		fmov.s	fr5,@-r0
		fmov.s	fr4,@-r0

		fmov.s	@r2+,fr4
		fadd	fr2,fr10
		fmov.s	@r2+,fr5
		fadd	fr1,fr9
		fmov.s	@r2+,fr6
		fadd	fr0,fr8

		fmov.s	fr10,@-r1
		fadd	fr2,fr6
		fmov.s	fr9,@-r1
		fadd	fr1,fr5
		fmov.s	fr8,@-r1
		fadd	fr0,fr4

		fmov.s	fr6,@-r2
		sub	r9,r0
		fmov.s	fr5,@-r2
		sub	r9,r1
		fmov.s	fr4,@-r2
		sub	r9,r2

		fneg	fr12
		dt	r7
		bf	_UberStrip_calcVertexNormals_stripVertex

		dt	r8
		bf	_UberStrip_calcVertexNormals_superStrip

		mov.l	@r15+,r4					! Finally, re-normalize the summed normals
_UberStrip_calcVertexNormals_normalizeNormal:

		fmov.s	@r6+,fr0
		fmov.s	@r6+,fr1
		fmov.s	@r6+,fr2
		fldi0	fr3
		fipr	fv0,fv0
		fsrra	fr3
		fmul	fr3,fr2
		fmul	fr3,fr1
		fmul	fr3,fr0
		fmov.s	fr2,@-r6
		fmov.s	fr1,@-r6
		dt	r4
		fmov.s	fr0,@-r6
		bf/s	_UberStrip_calcVertexNormals_normalizeNormal
		add	#Vtx_SIZEOF,r6
	
		lds.l	@r15+,pr
		mov.l	@r15+,r8
		mov.l	@r15+,r9
		rts
		fmov.s	@r15+,fr12

						.ALIGN	3
_UberStrip_calcVertexNormals_stdClearMem:	.LONG	_stdClearMem
_UberStrip_calcVertexNormals_addrMask:		.LONG	0x03ffffff
		
	


!----------------------------------------------------------------------
! void ApplyLighting(Vtx* vertices, Vtx* normals, int numVertices)
!
! Calculates lighting dot products, and packs result into Vtx.Color fields
!
! in	r4	Vtx*	vertices
!	r5	Vtx*	normals
!	r6	int	number of vertices
!

		.GLOBL	ApplyLighting
		.ALIGN	5
ApplyLighting:
		mov.l	r14,@-r15
		mov.l	r13,@-r15
		mov.l	r12,@-r15
		mov.l	r11,@-r15
		mov.l	r10,@-r15
		mov.l	r9,@-r15
		mov.l	r8,@-r15

		mov	#-8,r11
		mov	#-16,r12
		mov	#-24,r13
		mov	#0xff,r10
		extu.b	r10,r10
		mov	r10,r9
		mov	r10,r8
		shll8	r9
		pref	@r4
		shll16	r8
		mov	r9,r7
		shll16	r7
	
		mov	#0x80,r0
		shll8	r0
		or	#0x80,r0
		shll8	r0
		or	#0x80,r0
		shll8	r0
		or	#0x80,r0
		mov	r0,r14

		mov.l	r6,@-r15
		shlr	r6
		tst	r6,r6
		bt	ApplyLighting_singleVertex

		fmov.s	@r5+,fr0
		fmov.s	@r5+,fr1
		fmov.s	@r5+,fr2
		fldi1	fr3
		add	#4,r5
		ftrv	xmtrx,fv0

		pref	@r5

		ftrc	fr0,fpul
		sts	fpul,r0
		ftrc	fr1,fpul
		sts	fpul,r1
		ftrc	fr2,fpul
		
		dt	r6
		bt/s	ApplyLighting_nMultipleVertexPairs
		sts	fpul,r2

ApplyLighting_vertexPair:
		fmov.s	@r5+,fr0
		shld	r11,r1
		fmov.s	@r5+,fr1
		shld	r12,r2
		fmov.s	@r5+,fr2
		ftrc	fr3,fpul
		fldi1	fr3
		add	#4,r5
		and	r7,r0
		ftrv	xmtrx,fv0
		and	r8,r1

		sts	fpul,r3
		pref	@r5
		and	r9,r2
		shld	r13,r3
		or	r0,r2
		and	r10,r3

		ftrc	fr0,fpul
		or	r1,r3
		or	r2,r3
		sts	fpul,r0
		ftrc	fr1,fpul
		xor	r14,r3

		mov.l	r3,@(Vtx_Color,r4)

		sts	fpul,r1
		ftrc	fr2,fpul
		add	#Vtx_SIZEOF*2,r4
		
		sts	fpul,r2

		fmov.s	@r5+,fr0
		shld	r11,r1
		fmov.s	@r5+,fr1
		shld	r12,r2
		fmov.s	@r5+,fr2
		ftrc	fr3,fpul
		fldi1	fr3
		add	#4,r5
		pref	@r4
		add	#-Vtx_SIZEOF,r4
		and	r7,r0
		ftrv	xmtrx,fv0
		and	r8,r1

		sts	fpul,r3
		and	r9,r2
		shld	r13,r3
		or	r0,r2
		and	r10,r3

		ftrc	fr0,fpul
		or	r1,r3
		or	r2,r3
		sts	fpul,r0
		ftrc	fr1,fpul
		xor	r14,r3

		mov.l	r3,@(Vtx_Color,r4)
		dt	r6

		sts	fpul,r1
		ftrc	fr2,fpul
		ocbwb	@r4
		add	#Vtx_SIZEOF,r4
		
		bf/s	ApplyLighting_vertexPair
		sts	fpul,r2

ApplyLighting_nMultipleVertexPairs:

		fmov.s	@r5+,fr0
		shld	r11,r1
		fmov.s	@r5+,fr1
		shld	r12,r2
		fmov.s	@r5+,fr2
		ftrc	fr3,fpul
		fldi1	fr3
		add	#4,r5
		and	r7,r0
		ftrv	xmtrx,fv0
		and	r8,r1

		sts	fpul,r3
		pref	@r5
		and	r9,r2
		shld	r13,r3
		or	r0,r2
		and	r10,r3

		ftrc	fr0,fpul
		or	r1,r3
		or	r2,r3
		sts	fpul,r0
		ftrc	fr1,fpul
		xor	r14,r3

		mov.l	r3,@(Vtx_Color,r4)

		sts	fpul,r1
		ftrc	fr2,fpul
		add	#Vtx_SIZEOF,r4
	
		sts	fpul,r2

		shld	r11,r1
		shld	r12,r2
		ftrc	fr3,fpul
		and	r7,r0
		and	r8,r1

		sts	fpul,r3
		and	r9,r2
		shld	r13,r3
		or	r0,r2
		and	r10,r3

		or	r1,r3
		or	r2,r3
		xor	r14,r3

		mov.l	r3,@(Vtx_Color,r4)

		add	#Vtx_SIZEOF,r4

ApplyLighting_singleVertex:

		mov.l	@r15+,r0
		tst	#1,r0
		bf	ApplyLighting_nOddVertex

		fmov.s	@r5+,fr0
		fmov.s	@r5+,fr1
		fmov.s	@r5+,fr2
		fldi1	fr3
		add	#4,r5
		ftrv	xmtrx,fv0

		ftrc	fr0,fpul
		sts	fpul,r0
		ftrc	fr1,fpul
		sts	fpul,r1
		ftrc	fr2,fpul
		
		sts	fpul,r2

		shld	r11,r1
		shld	r12,r2
		ftrc	fr3,fpul
		and	r7,r0
		and	r8,r1

		sts	fpul,r3
		and	r9,r2
		shld	r13,r3
		or	r0,r2
		and	r10,r3

		or	r1,r3
		or	r2,r3
		xor	r14,r3

		mov.l	r3,@(Vtx_Color,r4)

ApplyLighting_nOddVertex:
		
		mov.l	@r15+,r8
		mov.l	@r15+,r9
		mov.l	@r15+,r10
		mov.l	@r15+,r11
		mov.l	@r15+,r12
		mov.l	@r15+,r13
		rts
		mov.l	@r15+,r14

