

FIRSTREG	= 0x00				! First PVR2 register to print to serial port
NUMREGS		= 0x80				! Number of registers to print


		.INCLUDE "PVR2_Regs.i"
		.INCLUDE "SH4_Regs.i"
		.INCLUDE "Screen.i"
	
		.SECTION .text

		.GLOBL	start
		.ALIGN	5
start:
		mov.l	start_Main,r0
		jmp	@r0
		nop

		.ALIGN	2
start_Main:	.long	Main

		.ALIGN	5

Main:
		sts.l	pr,@-r15

		mov.l	Main_InitFPU,r0
		jsr	@r0
		nop

		mov.l	Main_InitCache,r0
		jsr	@r0
		nop

		mov.l	Main_SetupExceptionHandler,r0
		jsr	@r0
		nop

!		bsr	PrintSomeHWRegs
		nop

		mov.l	Main_scInit,r0
		jsr	@r0
		nop
	
		add	#-8,r15
		mov	#640/8,r4
		shll2	r4
		shll	r4
		mov	#400/8,r5
		shll2	r5
		shll	r5
		mov	#SCREEN_HIRES,r6
		mov	#SCREEN_HIRES,r7
		mov	#SCREEN_60HZ,r0
		mov.l	r0,@(0,r15)
		mov	#SCREEN_ARGB8888,r0
		mov.l	r0,@(4,r15)
		mov.l	Main_scSetMode,r0
		jsr	@r0
		nop
		add	#8,r15

		mov.l	Main_scEnable,r0
		jsr	@r0
		mov	#1,r4

!		mov.l	Main_SetIMASK,r0
!		jsr	@r0
!		mov	#0,r4

!		mov	#60/4,r4
!		bsr	WaitVBLs
!		shll2	r4

		mov.l	Main_Draw3D,r0
		jsr	@r0
		nop
	
		mov.l	Main_BrowseVideoMemory,r0
		jsr	@r0
		nop

		mov.l	Main_SetIMASK,r0
		jsr	@r0
		mov	#0xf,r4

		mov.l	Main_DisableExceptionHandler,r0
		jsr	@r0
		nop

		mov.l	Main_DisableCache,r0
		jsr	@r0
		nop

		lds.l	@r15+,pr
		rts
		nop

				.ALIGN	5
Main_InitFPU:			.long	InitFPU
Main_InitCache:			.long	_InitCache
Main_SetupExceptionHandler:	.long	_SetupExceptionHandler
Main_SetIMASK:			.long	_SetIMASK
Main_scInit:			.long	_scInit
Main_scSetMode:			.long	_scSetMode
Main_scEnable:			.long	_scEnable
Main_DisableExceptionHandler:	.long	_DisableExceptionHandler
Main_DisableCache:		.long	_DisableCache
Main_BrowseVideoMemory:		.long	_BrowseVideoMemory
Main_Draw3D:			.long	_Draw3D
	
		.ALIGN	5
InitFPU:
		mov	#4,r0
		shll16	r0
		lds	r0,fpscr
		nop
		nop
		fschg
		fldi0	fr0
		fldi0	fr1
		fmov	dr0,dr2
		fmov	dr0,dr4
		fmov	dr0,dr6
		fmov	dr0,dr8
		fmov	dr0,dr10
		fmov	dr0,dr12
		fmov	dr0,dr14
		fmov	dr0,xd0
		fmov	dr0,xd2
		fmov	dr0,xd4
		fmov	dr0,xd6
		fmov	dr0,xd8
		fmov	dr0,xd10
		fmov	dr0,xd12
		fmov	dr0,xd14
		rts
		fschg


WaitVBLs:
		mov.l	r8,@-r15
		sts.l	pr,@-r15

		mov	r4,r8

WaitVBLs_wait:
		mov.l	WaitVBLs_scWaitVBL,r0
		jsr	@r0
		nop
		dt	r8
		bf	WaitVBLs_wait

		lds.l	@r15+,pr
		rts
		mov.l	@r15+,r8

			.ALIGN	2
WaitVBLs_scWaitVBL:	.long	_scWaitVBL

		.ALIGN	5
PrintSomeHWRegs:
		sts.l	pr,@-r15
		mov	#FIRSTREG,r8
		mov	#NUMREGS,r9
		extu.b	r8,r8
		extu.b	r9,r9

		mova	PrintSomeHWRegs_NewLineString,r0
		mov	r0,r10
		mov.l	PrintSomeHWRegs_SerialWriteChar,r11
		mov.l	PrintSomeHWRegs_SerialWriteHexByte,r12
		mov.l	PrintSomeHWRegs_SerialWriteHexLong,r13
		mov.l	PrintSomeHWRegs_SerialWriteString,r14

		jsr	@r13
		mov	r8,r4
		jsr	@r11
		mov	#':',r4
		jsr	@r14
		mov	r10,r4

PrintSomeHWRegs_printReg:
		jsr	@r11
		mov	#'0',r4
		jsr	@r11
		mov	#'x',r4
		jsr	@r12
		mov	r8,r4
		jsr	@r11
		mov	#' ',r4
		jsr	@r11
		mov	#'-',r4
		jsr	@r11
		mov	#' ',r4
		mov.l	PrintSomeHWRegs_PVR2Regs,r0
		mov	r8,r4
		shll2	r4
		add	r0,r4
		jsr	@r13
		mov.l	@r4,r4
		jsr	@r14
		mov	r10,r4

		add	#1,r8
		dt	r9
		bf	PrintSomeHWRegs_printReg

		lds.l	@r15+,pr
		rts
		nop

					.ALIGN	2
PrintSomeHWRegs_NewLineString:		.BYTE	0xd, 0xa, 0
					.ALIGN	2
PrintSomeHWRegs_SerialWriteChar:	.LONG	_SerialWriteChar
PrintSomeHWRegs_SerialWriteHexByte:	.LONG	_SerialWriteHexByte
PrintSomeHWRegs_SerialWriteHexLong:	.LONG	_SerialWriteHexLong
PrintSomeHWRegs_SerialWriteString:	.LONG	_SerialWriteString
PrintSomeHWRegs_PVR2Regs:		.LONG	PVR2REGS

