!
! Little rendering test
!
	
		.INCLUDE "PVR2_Regs.i"

		.GLOBL	_Draw3D
		.ALIGN	5
_Draw3D:
		sts.l	pr,@-r15

		bsr	ClearVideoMem
		nop

		bsr	InitRegionArray
		nop

		bsr	InitTA
		nop

		bsr	DrawFrame
		nop
		bsr	DrawFrame
		nop


		lds.l	@r15+,pr
		rts
		nop

ClearVideoMem:
		mov.l	ClearVideoMem_Base,r0
		mov.l	ClearVideoMem_Size,r1
		shlr2	r1
		mov	#0,r2
ClearVideoMem_Long:
		mov.l	r2,@r0
		dt	r1
		bf/s	ClearVideoMem_Long
		add	#4,r0
		rts

		.ALIGN	2
ClearVideoMem_Base:	.long	VIDEOMEMORY_32BIT
ClearVideoMem_Size:	.long	8*1024*1024


		.ALIGN	5
InitRegionArray:
		mov.l	r14,@-r15
		mov.l	r13,@-r15
		mov.l	r12,@-r15
		mov.l	r11,@-r15
		mov.l	r10,@-r15
		mov.l	r9,@-r15
		mov.l	r8,@-r15

		mov	#0x10,r8
		shll16	r8
		shll8	r8
		mov	#0x80,r9
		shll16	r9
		shll8	r9
		mov	#0xf0,r10
		shll16	r10
		shll8	r10
		mov	#0xa5,r11
		shll16	r11
		shll8	r11

		mov.l	RegionArrayBase,r14
		or	r11,r14

		mov.l	r8,@(0*4,r14)
		mov.l	r9,@(1*4,r14)
		mov.l	r9,@(2*4,r14)
		mov.l	r9,@(3*4,r14)
		mov.l	r9,@(4*4,r14)
		mov.l	r9,@(5*4,r14)
		add	#0x18,r14

		mov.l	DummyObjectPointerBlock,r12
		mov	#0,r0
		mov	r12,r1
		or	r11,r1
		add	#0x12*4,r1
		.rept	0x12
		mov.l	r0,@-r1
		.endr

		mov.l	ObjectPointerBlockArrayBase,r13
						
		mov	#0,r6
InitRegionArray_x:	
		mov	#0,r7
InitRegionArray_y:

		mov	r6,r0
		mov	r7,r1
		shll2	r0
		shll8	r1
		or	r1,r0
		mov.l	r0,@(0*4,r14)

		mov	#640/32,r0
		mul.l	r7,r0
		sts	macl,r0
		add	r6,r0
		shll8	r0
		shlr2	r0
		add	r13,r0
		mov.l	r0,@(1*4,r14)
		or	r11,r0
		mov	#0,r1
		mov.l	r1,@r0

		mov	r12,r0
		or	r9,r0
		mov.l	r0,@(2*4,r14)
		mov.l	r0,@(3*4,r14)
		mov.l	r0,@(4*4,r14)
		mov.l	r0,@(5*4,r14)

		add	#6*4,r14

		add	#1,r7
		mov	#480/32,r0
		cmp/hs	r0,r7
		bf	InitRegionArray_y
		add	#1,r6
		mov	#640/32,r0
		cmp/hs	r0,r6
		bf	InitRegionArray_x

		add	#-6*4,r14
		mov.l	@r14,r0
		or	r9,r0
		mov.l	r0,@r14

		mov.l	@r15+,r8
		mov.l	@r15+,r9
		mov.l	@r15+,r10
		mov.l	@r15+,r11
		mov.l	@r15+,r12
		mov.l	@r15+,r13
		rts
		mov.l	@r15+,r14



InitTA:
		mov.l	PVR2Regs,r7

		mov	#0xe8/4,r0		! blank screen
		shll2	r0
		mov.l	@(r0,r7),r1
		mov	#8,r2
		or	r2,r1
		mov.l	r1,@(r0,r7)
		mov	#0x44/4,r0		! disable display
		shll2	r0
		mov.l	@(r0,r7),r1
		mov	#0xfe,r2
		and	r2,r1
		mov.l	r1,@(r0,r7)
	
		mov	#-1,r0
		mov.l	r0,@(8,r7)		! Reset TA
		mov	#0,r0
		mov.l	r0,@(8,r7)		! Un-reset TA

		mova	InitTA_RegsToSetup,r0
InitTA_setReg:
		mov.l	@r0+,r1
		mov	#-1,r2
		cmp/eq	r1,r2
		bt	InitTA_setRegsDone
		mov.l	@r0+,r2
		bra	InitTA_setReg
		mov.l	r2,@r1

InitTA_setRegsDone:


		mov	#0x20,r1
		shll16	r1
		mov	#0x60/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)
		mov	#0x64/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov	#0xe8/4,r0		! unblank screen
		shll2	r0
		mov.l	@(r0,r7),r1
		mov	#0xf7,r2
		and	r2,r1
		mov.l	r1,@(r0,r7)
		mov	#0x44/4,r0		! enable display
		shll2	r0
		mov.l	@(r0,r7),r1
		mov	#1,r2
		or	r2,r1
		mov.l	r1,@(r0,r7)

		rts
		nop

		.ALIGN	5
DrawFrame:
		sts.l	pr,@-r15

		bsr	BeginFrame
		nop

		mov	#0xff,r0
		shll16	r0
		shll8	r0
		add	#0x38,r0
		mov	#0x10,r1
		mov.l	r1,@(0,r0)
		mov.l	r1,@(4,r0)

		mov	#-1,r6
		shlr2	r6
		shlr2	r6
		shlr2	r6
		mov	#0xe0,r7
		shll16	r7
		shll8	r7

		mova	DrawFrame_PolyHeader,r0
		bsr	SendToSQ
		nop

		mova	DrawFrame_Vertices,r0
		mov	r0,r8
		mov	#3*3,r9
sendvtx:
		bsr	SendToSQ
		mov	r8,r0

		add	#32,r8
		dt	r9
		bf	sendvtx

		mova	DrawFrame_EOL,r0
		bsr	SendToSQ
		nop

		bsr	FinishFrame

		lds.l	@r15+,pr
		rts
		nop

SendToSQ:
		mov	r0,r1
		and	r6,r1
		or	r7,r1
		mov.l	@r0+,r2
		mov.l	@r0+,r3
		mov.l	r2,@(0*4,r1)
		mov.l	r3,@(1*4,r1)
		mov.l	@r0+,r2
		mov.l	@r0+,r3
		mov.l	r2,@(2*4,r1)
		mov.l	r3,@(3*4,r1)
		mov.l	@r0+,r2
		mov.l	@r0+,r3
		mov.l	r2,@(4*4,r1)
		mov.l	r3,@(5*4,r1)
		mov.l	@r0+,r2
		mov.l	@r0+,r3
		mov.l	r2,@(6*4,r1)
		mov.l	r3,@(7*4,r1)
		pref	@r1
		rts
		nop



BeginFrame:
		mov	#0xa0,r0
		shll8	r0
		or	#0x5f,r0
		shll8	r0
		or	#0x69,r0
		shll8	r0
		mov	#-1,r1
		mov.l	r1,@r0

		mov.l	PVR2Regs,r7

		mov	#1,r0
		mov.l	r0,@(8,r7)
		mov	#0,r0
		mov.l	r0,@(8,r7)
	
		mov.l	ObjectPointerBlockArrayBase,r1
		mov	#0x124/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)
		mov	#0x164/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov.l	ScratchBase,r1
		mov	#0x128/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)
		
		mov.l	MiniScratchBase1,r1
		mov	#0x12c/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov.l	MiniScratchBase2,r1
		mov	#0x130/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov	#480/32,r1
		shll16	r1
		add	#640/32,r1
		mov	#0x13c/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov	#0x10,r1
		shll16	r1
		add	#2,r1
		mov	#2,r2
		shll8	r2
		or	r2,r1			! translucent enable?
		mov	#0x140/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov	#0x80,r1
		shll16	r1
		shll8	r1
		mov	#0x144/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)
		nop
		nop
		mov.l	@(r0,r7),r0

		rts
		nop


	
FinishFrame:
		sts.l	pr,@-r15
FinishFrame_wait:
		mov	#0xa0,r0
		shll8	r0
		or	#0x5f,r0
		shll8	r0
		or	#0x69,r0
		shll8	r0
		mov	r0,r1
		mov.l	@r1,r0
		tst	#0x80,r0
		bt	FinishFrame_wait

		mov	#0x80,r0
		extu.b	r0,r0
		mov.l	r0,@r1

		mov.l	PVR2Regs,r7
		mov	#0x138/4,r0
		shll2	r0
		mov.l	@(r0,r7),r6

		mov	r6,r2
		mov	#0xa5,r1
		shll16	r1
		shll8	r1
		or	r2,r1
		mova	BGPlane,r0
		mov	#18,r3
CopyLong:
		mov.l	@r0+,r2
		mov.l	r2,@r1
		dt	r3
		bf/s	CopyLong
		add	#4,r1

		mov.l	r6,@-r15

		mov.l	WaitVBL,r0
		jsr	@r0
		nop

		mov.l	@r15+,r6

		mov.l	PVR2Regs,r7

		mov.l	RegionArrayBase,r1
		mov	#0x2c/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov.l	ScratchBase,r1
		mov	#0x20/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov	#0x20,r1
		shll16	r1
		mov	#0x60/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov	#0x01,r1
		shll16	r1
		shll8	r1
		or	r6,r1
		mov	#0x8c/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov	#-1,r1
		mov	#0x14/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)
	
!		mov.l	ForceException,r0
!		jsr	@r0
!		nop
	
		lds.l	@r15+,pr
		rts
		nop

				.ALIGN	5
ForceException:			.long	_ForceException
WaitVBL:			.long	_WaitVBL
PVR2Regs:			.long	PVR2REGS
RegionArrayBase:		.long	0x080000
ObjectPointerBlockArrayBase:	.long	0x0c0000
DummyObjectPointerBlock:	.long	0x0b0000
ScratchBase:			.long	0x000000
MiniScratchBase1:		.long	0x010000
MiniScratchBase2:		.long	0x020000

				.ALIGN	5
InitTA_RegsToSetup:
				.long	PVR2REGS+0x00a8, 0x15d1c951
				.long	PVR2REGS+0x00a0, 0x00000020
				.long	PVR2REGS+0x0008, 0x00000000	! TA out of reset
				.long	PVR2REGS+0x0048, 0x00000009	!! alpha config
				!.long	PVR2REGS+0x0068, 0x02800000	!! pixel clipping x
				!.long	PVR2REGS+0x006c, 0x01e00000	!! pixel clipping y
				.long	PVR2REGS+0x0110, 0x00093f39
				.long	PVR2REGS+0x0098, 0x00800408
				.long	PVR2REGS+0x004c, 0x000000a0	!! display align (640*2)/8
				.long	PVR2REGS+0x0078, 0x3f800000	! polygon culling (1.0f)
				.long	PVR2REGS+0x0084, 0x00000000
				.long	PVR2REGS+0x0030, 0x00000101
				.long	PVR2REGS+0x0088, 0x3e4cccc0	! zclip, 0.2f
				.long	PVR2REGS+0x00b0, 0x007f7f7f	! fog table color
				.long	PVR2REGS+0x00b4, 0x007f7f7f	! fog vertex color
				.long	PVR2REGS+0x00b8, 0x0000ff07	! fog density
				.long	PVR2REGS+0x00bc, 0xffffffff	! color clamp max
				.long	PVR2REGS+0x00c0, 0x00000000	! color clamp min
				.long	PVR2REGS+0x0080, 0x00000007
				.long	PVR2REGS+0x0074, 0x00000001	! cheap shadow
				.long	PVR2REGS+0x007c, 0x0027df77
				.long	PVR2REGS+0x0008, 0x00000001	! TA reset
				.long	PVR2REGS+0x0008, 0x00000000	! TA out of reset
				.long	0xa05f6884, 0x00000000		! disable all interrupt events
				.long	0xa05f6930, 0x00000000
				.long	0xa05f6938, 0x00000000
				.long	0xa05f6900, 0xffffffff		! clear all pending int events
				.long	0xa05f6908, 0xffffffff
				.long	0xa05f6930, 0x002807ec		! re-enable some int events
				.long	0xa05f6938, 0x0000000e

				.long	PVR2REGS+0x00cc, 0x00150104
				.long	PVR2REGS+0x00e0, 0x07d6c63f	!! sync control
				.long	PVR2REGS+0x00c8, 0x03450000	!! same as border h in 0x00d4
				.long	PVR2REGS+0x0068, 0x027f0000	! tridi clip x ??
				.long	PVR2REGS+0x006c, 0x01df0000	! tridi clip y ??
				.long	PVR2REGS+0x0118, 0x00008040
				.long	PVR2REGS+0x00f4, 0x00000401	!! anti-aliasing
				.long	0xa05f7814, 0x00000000		! more interrupt stuff (so it seems)
				.long	0xa05f7834, 0x00000000
				.long	0xa05f7854, 0x00000000
				.long	0xa05f7874, 0x00000000
				.long	0xa05f78bc, 0x4659404f

				.long	PVR2REGS+0x0060, 0x00200000	! render output address
				.long	PVR2REGS+0x0064, 0x00200000	! render to texture output address

				.long	-1
	
				.ALIGN	5
DrawFrame_PolyHeader:		.long	0x80870012
				.long	0x90800000
				.long	0x20800440
				.long	0x00000000
				.long	-1,-1,-1,-1
DrawFrame_EOL:			.long	0,0,0,0,0,0,0,0

DrawFrame_Vertices:
				.long	0xe0000000
				.single	30.0, 20.0, 10.0
				.single	1.0, 0.5, 1.0, 1.0
				.long	0xe0000000
				.single	420.0, 210.0, 10.0
				.single	1.0, 1.0, 0.5, 1.0
				.long	0xf0000000
				.single	130.0, 400.0, 10.0
				.single	1.0, 1.0, 1.0, 0.5

				.long	0xe0000000
				.single	5.0, 5.0, 20.0
				.single	1.0, 0.5, 1.0, 1.0
				.long	0xe0000000
				.single	12.0, 4.0, 20.0
				.single	1.0, 1.0, 0.5, 1.0
				.long	0xf0000000
				.single	70.0, 10.0, 20.0
				.single	1.0, 1.0, 1.0, 0.5

				.long	0xe0000000
				.single	100.0, 25.0, 30.0
				.single	1.0, 0.5, 1.0, 1.0
				.long	0xe0000000
				.single	200.0, 110.0, 5.0
				.single	1.0, 1.0, 0.5, 1.0
				.long	0xf0000000
				.single	150.0, 170.0, 5.0
				.single	1.0, 1.0, 1.0, 0.5

BGPlane:
				.long	0x90800000, 0x20800440, 0
				.single	0.0, 480.0, 0.2
				.long	0xff7f7f7f
				.single	0.0, 0.0, 0.2
				.long	0xff7f7f7f
				.single	640.0, 480.0, 0.2
				.long	0xff7f7f7f
				.long	0, 0, 0
