!
! Test receiving IRQs from TA/3D
!

		.INCLUDE "PVR2_Regs.i"

		.GLOBL	_Draw3D
		.ALIGN	5
_Draw3D:
		sts.l	pr,@-r15

		bsr	ClearVideoMem
		nop

		mova	IRQ9Handler,r0
		mov	r0,r5
		mov	#0x320>>4,r4
		mov.l	SetExceptionEventHandler,r0
		shll2	r4
		jsr	@r0
		shll2	r4
	
		mov.l	SetIMASK,r0
		jsr	@r0
		mov	#0,r4

		bsr	InitTileArray
		nop

		bsr	InitTA
		nop

		bsr	DrawFrame
		nop
!		bsr	DrawFrame
!		nop

		lds.l	@r15+,pr
		rts
		nop

				.ALIGN	2
SetIMASK:			.long	_SetIMASK
SetExceptionEventHandler:	.long	_SetExceptionEventHandler
	

ClearVideoMem:
		mov.l	ClearVideoMem_Base,r0
		mov.l	ClearVideoMem_Size,r1
		shlr2	r1
		mov	#0,r2
ClearVideoMem_Long:
		mov.l	r2,@r0
		dt	r1
		bf/s	ClearVideoMem_Long
		add	#4,r0
		rts

		.ALIGN	2
ClearVideoMem_Base:	.long	VIDEOMEMORY_32BIT
ClearVideoMem_Size:	.long	8*1024*1024


		.ALIGN	2
IRQ9Handler:
		sts.l	pr,@-r15

		mov	#0xa0,r0
		shll8	r0
		or	#0x5f,r0
		shll8	r0
		or	#0x69,r0
		shll8	r0
		mov	r0,r7

		mova	IRQ9Handlers1,r0
		bsr	IRQ9Handler_ScanForIRQs
		mov	r0,r4

		mova	IRQ9Handlers2,r0
		mov	r0,r4
		bsr	IRQ9Handler_ScanForIRQs
		add	#8,r7
	

		lds.l	@r15+,pr
		rts
		nop


!	r4	func[]	handlers
!	r7	uint32*	irqreg

IRQ9Handler_ScanForIRQs:
		mov.l	@(0x30,r7),r6

		mov.l	@r7,r0
		and	r6,r0
		tst	r0,r0
		bt	IRQ9Handler_noInts

		mov	#-1,r1
		shll16	r1
		mov	#0,r5
		tst	r1,r0
		bt	IRQ9Handler_ScanForIRQs_low16
		shlr16	r0
		add	#16,r5
IRQ9Handler_ScanForIRQs_low16:
		shlr8	r1
		tst	r1,r0
		bt	IRQ9Handler_ScanForIRQs_low8
		shlr8	r0
		add	#8,r5
IRQ9Handler_ScanForIRQs_low8:
		tst	#0xf0,r0
		bt	IRQ9Handler_ScanForIRQs_low4
		shlr2	r0
		shlr2	r0
		add	#4,r5
IRQ9Handler_ScanForIRQs_low4:
		tst	#0xc,r0
		bt	IRQ9Handler_ScanForIRQs_low2
		shlr2	r0
		add	#2,r5
IRQ9Handler_ScanForIRQs_low2:
		tst	#2,r0
		movt	r1
		add	#1,r5
		sub	r1,r5

		mov	#1,r0
		shld	r5,r0
		mov.l	r0,@r7

		sts.l	pr,@-r15
		mov.l	r7,@-r15
		mov.l	r4,@-r15

		mov	r5,r0
		shll2	r0
		mov.l	@(r0,r4),r0
		jsr	@r0
		nop

		mov.l	@r15+,r4
		mov.l	@r15+,r7
		lds.l	@r15+,pr

		bra	IRQ9Handler_ScanForIRQs
		nop

IRQ9Handler_noInts:

		rts
		nop

IRQ9_DefaultHandler:
		mov.l	r10,@-r15
		mov.l	r9,@-r15
		mov.l	r8,@-r15
		sts.l	pr,@-r15

		mov.l	r5,@-r15
		mov.l	r7,@-r15

		mov.l	IRQ9_SerialWriteString,r8
		mov.l	IRQ9_SerialWriteHexLong,r9
		mov.l	IRQ9_SerialWriteChar,r10

		mov	#0xf,r4
		and	r7,r4
		shlr2	r4
		shlr	r4
		jsr	@r10
		add	#'x',r4

!		mova	IRQ9_ErrorMsg,r0
!		jsr	@r8
!		mov	r0,r4
!
!		jsr	@r9
		mov.l	@r15+,r4
!
		jsr	@r9
		mov.l	@r15+,r4
!
!		mova	IRQ9_ErrorMsg2,r0
!		jsr	@r8
!		mov	r0,r4

		lds.l	@r15+,pr
		mov.l	@r15+,r8
		mov.l	@r15+,r9
		rts
		mov.l	@r15+,r10


				.ALIGN	2
IRQ9_SetIMASK:			.long	_SetIMASK
IRQ9_SerialWriteString:		.long	_SerialWriteString
IRQ9_SerialWriteHexLong:	.long	_SerialWriteHexLong
IRQ9_SerialWriteChar:		.long	_SerialWriteChar
				.ALIGN	2
IRQ9_ErrorMsg:			.asciz	"Unhandled IRQ9: "
				.ALIGN	2
IRQ9_ErrorMsg2:			.byte	0xd, 0xa, 0

		.ALIGN	2
IRQ9_ScanlineIntHandler:
		mov	#0xa0,r0
		shll8	r0
		or	#0x5f,r0
		shll8	r0
		or	#0x80,r0
		shll8	r0
		or	#0x40,r0
		mov	r0,r1
		mova	IRQ9_Scanline_BGColor,r0
		mov.l	@r0,r2
!		add	#0x10,r2
		not	r2,r2
		mov.l	r2,@r0
!		mov.l	r2,@r1
		rts
		nop

		.ALIGN	2
IRQ9_Scanline_BGColor:
		.long	0
IRQ9Handlers1:
		.REPT	3
		.long	IRQ9_DefaultHandler
		.ENDR
		.long	IRQ9_ScanlineIntHandler
		.REPT	32-4
		.long	IRQ9_DefaultHandler
		.ENDR
IRQ9Handlers2:
		.REPT	32
		.long	IRQ9_DefaultHandler
		.ENDR

		.ALIGN	5
InitTileArray:
		mov.l	r14,@-r15
		mov.l	r13,@-r15
		mov.l	r12,@-r15
		mov.l	r11,@-r15
		mov.l	r10,@-r15
		mov.l	r9,@-r15
		mov.l	r8,@-r15

		mov	#0x10,r8
		shll16	r8
		shll8	r8
		mov	#0x80,r9
		shll16	r9
		shll8	r9
		mov	#0xf0,r10
		shll16	r10
		shll8	r10
		mov	#0xa5,r11
		shll16	r11
		shll8	r11

		mov.l	TileArrayBase,r14
		or	r11,r14

		mov.l	r8,@(0*4,r14)			! Init-tile (is this necessary?)
		mov.l	r9,@(1*4,r14)
		mov.l	r9,@(2*4,r14)
		mov.l	r9,@(3*4,r14)
		mov.l	r9,@(4*4,r14)
		mov.l	r9,@(5*4,r14)
		add	#6*4,r14

		mov	#0,r7
InitTileArray_y:
		mov	#0,r6
InitTileArray_x:	

		mov	r6,r0
		mov	r7,r1
		shll2	r0
		shll8	r1
		or	r1,r0
		mov.l	r0,@(0*4,r14)

		mov	#640/32,r0
		mul.l	r7,r0
		sts	macl,r0
		add	r6,r0
		shll8	r0
		shlr2	r0
		mov.l	OpaquePPBlockArrayBase,r1
		add	r0,r1
!		mov	r9,r1
		mov.l	r1,@(1*4,r14)
		mov.l	TranslucentPPBlockArrayBase,r1
		add	r0,r1
!		mov	r9,r1
		mov.l	r1,@(3*4,r14)
	
		mov.l	r9,@(2*4,r14)
		mov.l	r9,@(4*4,r14)
		mov.l	r9,@(5*4,r14)

		add	#6*4,r14

		add	#1,r6
		mov	#640/32,r0
		cmp/hs	r0,r6
		bf	InitTileArray_x
		add	#1,r7
		mov	#480/32,r0
		cmp/hs	r0,r7
		bf	InitTileArray_y

		add	#-6*4,r14
		mov.l	@r14,r0
		or	r9,r0
		mov.l	r0,@r14

		mov.l	@r15+,r8
		mov.l	@r15+,r9
		mov.l	@r15+,r10
		mov.l	@r15+,r11
		mov.l	@r15+,r12
		mov.l	@r15+,r13
		rts
		mov.l	@r15+,r14



InitTA:
		sts.l	pr,@-r15

		mov.l	InitTA_scEnable,r0
		jsr	@r0
		mov	#0,r4
	
		mov.l	PVR2Regs,r7

		mov	#3,r0			! Is it necessary to reset both TA + 3D?
		mov.l	r0,@(COREDISABLE*4,r7)	! Reset TA + 3D
		mov	#0,r0
		mov.l	r0,@(COREDISABLE*4,r7)	! Un-reset TA + 3D

		mova	InitTA_RegsToSetup,r0
InitTA_setReg:
		mov.l	@r0+,r1
		mov	#-1,r2
		cmp/eq	r1,r2
		bt	InitTA_setRegsDone
		mov.l	@r0+,r2
		bra	InitTA_setReg
		mov.l	r2,@r1

InitTA_setRegsDone:

		mov	#640*2/8,r1
		extu.b	r1,r1
		mov	#RENDERPITCH,r0		! (3D) Render output pitch
		shll2	r0
		mov.l	r1,@(r0,r7)
		mov	#0x20,r1
		shll16	r1
		mov	#RENDERBASE,r0		! (3D) Render output address
		shll2	r0
		mov.l	r1,@(r0,r7)
		mov	#0x20,r1
		shll16	r1
		add	#0x60,r1
		mov	#0x64/4,r0		! (3D) Render to texture output address ??
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov.l	InitTA_scEnable,r0
		jsr	@r0
		mov	#1,r4

		lds.l	@r15+,pr
	
		rts
		nop

			.ALIGN	2
InitTA_scEnable:	.long	_scEnable



		.ALIGN	5
DrawFrame:
		mov.l	r9,@-r15
		mov.l	r8,@-r15
		sts.l	pr,@-r15

		bsr	BeginFrame
		nop

		mov.l	scWaitVBL,r0
		jsr	@r0
		nop
	
		mov	#0xff,r0
		shll16	r0
		shll8	r0
		add	#0x38,r0
		mov	#0x10,r1
		mov.l	r1,@(0,r0)
		mov.l	r1,@(4,r0)

		mov	#-1,r6
		shlr2	r6
		shlr2	r6
		shlr2	r6
		mov	#0xe0,r7
		shll16	r7
		shll8	r7

		mova	DrawFrame_TAData,r0
		mov	r0,r8

		mov	#1+1*3+18*2*3+1+1+1*3+1,r9
		extu.b	r9,r9
sendvtx:
		bsr	SendToSQ
		mov	r8,r0

		add	#32,r8
		dt	r9
		bf	sendvtx

		mov.l	scWaitVBL,r0
		jsr	@r0
		nop
		mov.l	scWaitVBL,r0
		jsr	@r0
		nop
		mov.l	scWaitVBL,r0
		jsr	@r0
		nop

		bsr	FinishFrame
		nop

		mov.l	scWaitVBL,r0
		jsr	@r0
		nop
		mov.l	scWaitVBL,r0
		jsr	@r0
		nop

		lds.l	@r15+,pr
		mov.l	@r15+,r8
		rts
		mov.l	@r15+,r9


		.ALIGN	5
SendToSQ:
		mov	r0,r1
		and	r6,r1
		or	r7,r1
		mov.l	@r0+,r2
		mov.l	@r0+,r3
		mov.l	r2,@(0*4,r1)
		mov.l	r3,@(1*4,r1)
		mov.l	@r0+,r2
		mov.l	@r0+,r3
		mov.l	r2,@(2*4,r1)
		mov.l	r3,@(3*4,r1)
		mov.l	@r0+,r2
		mov.l	@r0+,r3
		mov.l	r2,@(4*4,r1)
		mov.l	r3,@(5*4,r1)
		mov.l	@r0+,r2
		mov.l	@r0+,r3
		mov.l	r2,@(6*4,r1)
		mov.l	r3,@(7*4,r1)
		rts
		pref	@r1



BeginFrame:
		mov	#0xa0,r0		! Clear all pending ints
		shll8	r0
		or	#0x5f,r0
		shll8	r0
		or	#0x69,r0
		shll8	r0
		mov	#-1,r1
		mov.l	r1,@r0

		mov.l	PVR2Regs,r7

		mov	#1,r0			! Reset TA
		mov.l	r0,@(COREDISABLE*4,r7)
		mov	#0x0,r0			! Un-reset TA
		mov.l	r0,@(COREDISABLE*4,r7)
	
		mov.l	OpaquePPBlockArrayBase,r1	! (TA) Set base address for the root PP-block matrices
		mov	#0x124/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov.l	TAPrimitiveAllocationStart,r1	! (TA) Set allocation range for PP-blocks
		mov	#0x128/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)
		mov.l	TAPrimitiveAllocationEnd,r1
		mov	#0x130/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov.l	TAPPBlockAllocationStart,r1	! (TA) Set allocation range for primitives
		mov	#0x12c/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)
		mov.l	TAPPBlockAllocationEnd,r1
		mov	#0x164/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov	#(480/32)-1,r1
		shll16	r1
		add	#(640/32)-1,r1
		mov	#0x13c/4,r0		! (TA) Tile array dimensions
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov	#0x10,r1
		shll16	r1			! TA pp-block sizes
		add	#2,r1			! opaque pp-blocks - 16 entries/pp-block
		mov	#2,r2			! translucent pp-blocks - 16 entries/pp-block
		shll8	r2
		or	r2,r1
		mov	#0x140/4,r0
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov	#0x144/4,r0		! (TA) Roll it - time for new vertex registration
		shll2	r0
		mov.l	r0,@(r0,r7)
!		mov.l	@(r0,r7),r0		! (Wait for TA to be ready?) Is this read really necessary?

		rts
		nop


	
FinishFrame:
		sts.l	pr,@-r15
!FinishFrame_wait:					! Wait for TA to finish enqueueing all lists
!		mov	#0xa0,r0
!		shll8	r0
!		or	#0x5f,r0
!		shll8	r0
!		or	#0x69,r0
!		shll8	r0
!		mov	r0,r1
!		mov.l	@r1,r0
!		tst	#0x2,r0
!		bt	FinishFrame_wait
!	
!		mov	#0x2,r0
!		extu.b	r0,r0
!		mov.l	r0,@r1

		mov.l	PVR2Regs,r7
		mov	#0x138/4,r0			! (TA) Current primitive allocation position
		shll2	r0
		mov.l	@(r0,r7),r6

		mov.l	BGPlaneLocation,r2		! Stuff BG plane into graphics memory
		mov	#0xa5,r1
		shll16	r1
		shll8	r1
		or	r2,r1
		mova	BGPlane,r0
		mov	#15,r3
CopyLong:
		mov.l	@r0+,r2
		mov.l	r2,@r1
		dt	r3
		bf/s	CopyLong
		add	#4,r1

		mov.l	scWaitVBL,r0
		jsr	@r0
		nop

		mov.l	PVR2Regs,r7

		mov.l	TileArrayBase,r1
		mov	#0x2c/4,r0				! (3D) Tile Array
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov.l	PrimitiveAllocationBase,r1
		mov	#0x20/4,r0				! (3D) MB-number of primitive allocation area
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov.l	RenderOutputBase,r1
		mov	#0x60/4,r0				! (3D) Output base address
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov.l	BGPlaneLocation,r2
		mov.l	PrimitiveAllocationBase,r3
		sub	r3,r2
		shll	r2
		shll8	r2
		shlr8	r2
		mov	#0x01,r1
		shll16	r1
		shll8	r1
		or	r2,r1
		mov	#0x8c/4,r0			! (3D) BG plane location
		shll2	r0
		mov.l	r1,@(r0,r7)

		mov	#0x14/4,r0			! (3D) kick it. commence rendering. all bets are off.
		shll2	r0
		mov.l	r0,@(r0,r7)
	
!		mov.l	ForceException,r0
!		jsr	@r0
!		nop
	
		lds.l	@r15+,pr
		rts
		nop

				.ALIGN	5
ForceException:			.long	_ForceException
scWaitVBL:			.long	_scWaitVBL
PVR2Regs:			.long	PVR2REGS
TileArrayBase:			.long	0x080000
OpaquePPBlockArrayBase:		.long	0x120000
TranslucentPPBlockArrayBase:	.long	0x120000+(640/32)*(480/32)*16*4		! 124b00
PrimitiveAllocationBase:	.long	0x300000	! 1MB-aligned; should be the MB-address of TAPrimitiveAllocationStart
RenderOutputBase:		.long	0x200000
TAPPBlockAllocationStart:	.long	0x118000
TAPPBlockAllocationEnd:		.long	0x11c000
TAPrimitiveAllocationStart:	.long	0x300040
TAPrimitiveAllocationEnd:	.long	0x310000
BGPlaneLocation:		.long	0x300000	! Must be after PrimitiveAllocationBase
	
				.ALIGN	5
InitTA_RegsToSetup:
				.long	PVR2REGS+0x00a8, 0x15d1c951	! (PVR) memory control
				.long	PVR2REGS+0x00a0, 0x00000020	! (unknown)
				.long	PVR2REGS+0x0008, 0x00000000	! TA out of reset
				.long	PVR2REGS+0x0048, 0x00000009	! (3D) render format
				.long	PVR2REGS+0x0110, 0x00093f39	! (unknown)
				.long	PVR2REGS+0x0098, 0x00800408	! (unknown)
				.long	PVR2REGS+0x0078, 0x3f800000	! polygon culling (1.0f)
				.long	PVR2REGS+0x0084, 0x00000000	! (unknown)
				.long	PVR2REGS+0x0030, 0x00000101	! (unknown)
				.long	PVR2REGS+0x0088, 0x3e4cccc0	! zclip, 0.2f
				.long	PVR2REGS+0x00b0, 0x007f7f7f	! (3D) fog table color
				.long	PVR2REGS+0x00b4, 0x007f7f7f	! (3D) fog vertex color
				.long	PVR2REGS+0x00b8, 0x0000ff07	! (3D) fog density
				.long	PVR2REGS+0x00bc, 0xffffffff	! (3D) color clamp max
				.long	PVR2REGS+0x00c0, 0x00000000	! (3D) color clamp min
				.long	PVR2REGS+0x0080, 0x00000007	! (unknown)
				.long	PVR2REGS+0x0074, 0x00000001	! (3D) cheap shadow
				.long	PVR2REGS+0x007c, 0x0027df77	! (unknown)
				.long	PVR2REGS+0x0008, 0x00000001	! TA reset
				.long	PVR2REGS+0x0008, 0x00000000	! TA out of reset
				.long	0xa05f6884, 0x00000000		! disable all interrupt events
				.long	0xa05f6930, 0x00000000
				.long	0xa05f6938, 0x00000000
				.long	0xa05f6900, 0xffffffff		! clear all pending int events
				.long	0xa05f6908, 0xffffffff
!				.long	0xa05f6930, 0x002807ec		! re-enable some int events
!				.long	0xa05f6938, 0x0000000e
				.long	0xa05f6930, 0xffffffcf		! re-enable practically all int events
				.long	0xa05f6938, 0xffffffff

				.long	PVR2REGS+0x00cc, 0x00150104	! (2D) scanline interrupt pos (should be setup somewhere else)
				.long	PVR2REGS+0x0068, (640-1)<<16+0	! (3D) tridi clip x
				.long	PVR2REGS+0x006c, (480-1)<<16+0	! (3D) tridi clip y
				.long	PVR2REGS+0x0118, 0x00008040	! (3D) Output colour scale/add ?
				.long	PVR2REGS+0x00f4, 0x00000400	! (3D) output XY compression
!				.long	0xa05f7814, 0x00000000		! more interrupt stuff (so it seems)
!				.long	0xa05f7834, 0x00000000
!				.long	0xa05f7854, 0x00000000
!				.long	0xa05f7874, 0x00000000
!				.long	0xa05f78bc, 0x4659404f

				.long	-1
	

				.ALIGN	5
BGPlane:
				.long	0x90800000, 0x20800440, 0
				.single	0.0, 480.0, 0.2
				.long	0x7f7f7f00
				.single	0.0, 0.0, 0.2
				.long	0xe0007f7f
				.single	640.0, 480.0, 0.2
				.long	0x407f007f


				.ALIGN	6
DrawFrame_TAData:
				.long	0x80840012
				.long	0x90800000
				.long	0x20800440
				.long	0x00000000
				.long	-1,-1,-1,-1

				.long	0xe0000000
				.single	5.0, 5.0, 20.0
				.single	1.0, 0.5, 1.0, 1.0
				.long	0xe0000000
				.single	23.0, 10.0, 20.0
				.single	1.0, 1.0, 0.5, 1.0
				.long	0xf0000000
				.single	7.0, 20.0, 20.0
				.single	1.0, 1.0, 1.0, 0.5

				.rept	18
				.long	0xe0000000
				.single	100.0, 25.0, 30.0
				.single	1.0, 0.5, 1.0, 1.0
				.long	0xe0000000
				.single	200.0, 110.0, 5.0
				.single	1.0, 1.0, 0.5, 1.0
				.long	0xf0000000
				.single	150.0, 170.0, 5.0
				.single	1.0, 1.0, 1.0, 0.5

				.long	0xe0000000
				.single	101.0, 26.0, 30.0
				.single	1.0, 0.5, 1.0, 1.0
				.long	0xe0000000
				.single	601.0, 111.0, 5.0
				.single	1.0, 1.0, 0.5, 1.0
				.long	0xf0000000
				.single	151.0, 171.0, 5.0
				.single	1.0, 1.0, 1.0, 0.5
				.endr
	
				.long	0, 0, 0, 0, 0, 0, 0, 0

				.long	0x82840012
				.long	0x90800000
				.long	0x949004c0
				.long	0x00000000
				.long	-1,-1,-1,-1

				.long	0xe0000000
				.single	10.0, 10.0, 10.0
				.single	1.0, 0.5, 1.0, 1.0
				.long	0xe0000000
				.single	420.0, 210.0, 10.0
				.single	1.0, 1.0, 0.5, 1.0
				.long	0xf0000000
				.single	130.0, 400.0, 10.0
				.single	0.0, 1.0, 1.0, 0.5

				.long	0, 0, 0, 0, 0, 0, 0, 0

