!
! Another test of the rendering module
!
	
		.INCLUDE "PVR2_Regs.i"
		.INCLUDE "Render.i"

		.SECTION .text

		.GLOBL	_Draw3D
		.ALIGN	5
_Draw3D:
		sts.l	pr,@-r15

!		bsr	ClearGfxMem
!		nop
	
		mov.l	_Draw3D_rdInit,r0
		jsr	@r0
		nop

		mov.l	_Draw3D_SetIMASK,r0
		jsr	@r0
		mov	#0,r4

		add	#-8,r15
		mov.l	_Draw3D_rdSetupNativeBuffers,r0
		mov	#RENDER_BUCKETSIZE_16,r4
		mov	#RENDER_BUCKETSIZE_0,r5
		mov	#RENDER_BUCKETSIZE_16,r6
		mov	#RENDER_BUCKETSIZE_0,r7
		mov	#0x10,r1
		mov.l	r7,@(0,r15)
		shll16	r1
		jsr	@r0
		mov.l	r1,@(4,r15)
		nop
		add	#8,r15

		mov.l	_Draw3D_rdSetupVertexBuffer,r0
		mov.l	_Draw3D_OpaqueBufferStart,r5
		mov.l	_Draw3D_OpaqueBufferLength,r6
		jsr	@r0
		mov	#RENDER_LIST_OPAQUE,r4

		mov.l	_Draw3D_rdSetupVertexBuffer,r0
		mov.l	_Draw3D_TranslucentBufferStart,r5
		mov.l	_Draw3D_TranslucentBufferLength,r6
		jsr	@r0
		mov	#RENDER_LIST_TRANSLUCENT,r4

Draw3D_frame:
		bsr	DrawFrame
		nop

		mov.l	_Draw3D_SerialCheckInput,r0
		jsr	@r0
		nop

		tst	r0,r0
		bt	Draw3D_frame
	
		mov.l	_Draw3D_rdShutdown,r0
		jsr	@r0
		nop

		lds.l	@r15+,pr
		rts
		nop

				.ALIGN	5
_Draw3D_rdInit:			.long	_rdInit
_Draw3D_rdSetupNativeBuffers:	.long	_rdSetupNativeBuffers
_Draw3D_rdShutdown:		.long	_rdShutdown
_Draw3D_rdSetupVertexBuffer:	.long	_rdSetupVertexBuffer
_Draw3D_SetIMASK:		.long	_SetIMASK
_Draw3D_OpaqueBufferStart:	.long	0x8c040000
_Draw3D_OpaqueBufferLength:	.long	0x00010000
_Draw3D_TranslucentBufferStart:	.long	0x8c050000
_Draw3D_TranslucentBufferLength: .long	0x00010000
_Draw3D_SerialCheckInput:	.long	_SerialCheckInput
	
ClearGfxMem:
		mov	#0x80/4,r1
		shll16	r1
		mov	#0xa5,r0
		shll16	r0
		shll8	r0
		mov	#0,r2
ClearGfxMem_long:
		dt	r1
		mov.l	r2,@r0
		bf/s	ClearGfxMem_long
		add	#4,r0
		rts
		nop

		.ALIGN	5
DrawFrame:
		mov.l	r9,@-r15
		mov.l	r8,@-r15
		sts.l	pr,@-r15

		mov.l	DrawFrame_rdBeginScene,r0
		jsr	@r0
		mov	#0,r4				! Normal mode, please

		mov.l	DrawFrame_rdSetupDirectPath,r0
		jsr	@r0
		mov	#RENDER_LIST_OPAQUE,r4		! Opaque list as Direct Path

		mov.l	DrawFrame_OpaquePrimitives,r0	! Submit some opaque prims
		mov	#RENDER_LIST_OPAQUE,r4
		mov	r0,r5
		mov	#1+3*3,r6
		shll2	r6
		mov.l	DrawFrame_rdDrawPrimitives,r0
		shll2	r6
		jsr	@r0
		shll	r6

		mov.l	DrawFrame_TranslucentPrimitives,r0	! Submit some translucent prims
		mov	#RENDER_LIST_TRANSLUCENT,r4
		mov	r0,r5
		mov	#1+1*3,r6
		shll2	r6
		mov.l	DrawFrame_rdDrawPrimitives,r0
		shll2	r6
		jsr	@r0
		shll	r6

		mov.l	DrawFrame_rdFinishDirectPath,r0
!		jsr	@r0
		nop

		mov.l	DrawFrame_rdEndScene,r0		! Done with scene
		jsr	@r0
		nop

		mov.l	DrawFrame_rdFlip,r0
		jsr	@r0
		nop

		lds.l	@r15+,pr
		mov.l	@r15+,r8
		rts
		mov.l	@r15+,r9


		.ALIGN	5
SendToSQ:
		mov	r0,r1
		and	r6,r1
		or	r7,r1
		mov.l	@r0+,r2
		mov.l	@r0+,r3
		mov.l	r2,@(0*4,r1)
		mov.l	r3,@(1*4,r1)
		mov.l	@r0+,r2
		mov.l	@r0+,r3
		mov.l	r2,@(2*4,r1)
		mov.l	r3,@(3*4,r1)
		mov.l	@r0+,r2
		mov.l	@r0+,r3
		mov.l	r2,@(4*4,r1)
		mov.l	r3,@(5*4,r1)
		mov.l	@r0+,r2
		mov.l	@r0+,r3
		mov.l	r2,@(6*4,r1)
		mov.l	r3,@(7*4,r1)
		rts
		pref	@r1

				.ALIGN	5
DrawFrame_rdBeginScene:		.long	_rdBeginScene
DrawFrame_rdEndScene:		.long	_rdEndScene
DrawFrame_rdFlip:		.long	_rdFlip
DrawFrame_rdSetupDirectPath:	.long	_rdSetupDirectPath
DrawFrame_rdFinishDirectPath:	.long	_rdFinishDirectPath
DrawFrame_rdDrawPrimitives:	.long	_rdDrawPrimitives
DrawFrame_OpaquePrimitives:	.long	OpaquePrimitives
DrawFrame_TranslucentPrimitives: .long	TranslucentPrimitives



				.ALIGN	5
OpaquePrimitives:
				.long	0x80840012
				.long	0x90800000
				.long	0x20800440
				.long	0x00000000
				.long	-1,-1,-1,-1

				.long	0xe0000000
				.single	5.0, 5.0, 20.0
				.single	1.0, 0.5, 1.0, 1.0
				.long	0xe0000000
				.single	23.0, 10.0, 20.0
				.single	1.0, 1.0, 0.5, 1.0
				.long	0xf0000000
				.single	7.0, 20.0, 20.0
				.single	1.0, 1.0, 1.0, 0.5

				.long	0xe0000000
				.single	100.0, 25.0, 30.0
				.single	1.0, 0.5, 1.0, 1.0
				.long	0xe0000000
				.single	200.0, 110.0, 5.0
				.single	1.0, 1.0, 0.5, 1.0
				.long	0xf0000000
				.single	150.0, 170.0, 5.0
				.single	1.0, 1.0, 1.0, 0.5

				.long	0xe0000000
				.single	101.0, 26.0, 30.0
				.single	1.0, 0.5, 1.0, 1.0
				.long	0xe0000000
				.single	601.0, 111.0, 5.0
				.single	1.0, 1.0, 0.5, 1.0
				.long	0xf0000000
				.single	151.0, 171.0, 5.0
				.single	1.0, 1.0, 1.0, 0.5

				.ALIGN	5
TranslucentPrimitives:
				.long	0x82840012
				.long	0x90800000
				.long	0x949004c0
				.long	0x00000000
				.long	-1,-1,-1,-1

				.long	0xe0000000
				.single	10.0, 10.0, 10.0
				.single	1.0, 0.5, 1.0, 1.0
				.long	0xe0000000
				.single	420.0, 210.0, 10.0
				.single	1.0, 1.0, 0.5, 1.0
				.long	0xf0000000
				.single	130.0, 400.0, 10.0
				.single	0.0, 1.0, 1.0, 0.5
